#ifndef _KNOWLEDGE_H__
#define _KNOWLEDGE_H_


#include "bedelingen.h"

class knowledge
{   
          int                       d_know [4][41];
          int                       d_owner;
          Bedelingen                d_bedelingen[4];
          std::vector<std::string>  d_combined;
          int                       d_opener;
          
      public:       
          knowledge(int player);
      
          void update(int x, int y);// player X doenst have Y points
          void update_range(int x, int y_lower, int y_higher);// player X's points range from Y_lower to Y_higher
          void set(int X, int Y); // player X has exactly Y points
          
          
          void setOpener(int opener)
          {
               d_opener = opener;
          }
          int getOpener()
          {
               return d_opener;
          }
          int kmin(int speler)
          {
              int min = 0;
              while (min != 41)
              {
                    if (d_know[speler][min] == 1)
                       return min;
                    ++min;
              }
              return 0;
          }
          
          int kmax(int speler)
          {
              int max = 40;
              while (max != 0)
              {
                  if (d_know[speler][max] == 1)
                     return max;
                  --max;
              }
              return 40;
          }
          
          Bedelingen &bedeling(int player)
          {
              return d_bedelingen[player];
          }
          
          void setAvailable(int A, int K, int Q, int J)
          {
               for (unsigned idx = 0; idx < 4; ++idx)
                   d_bedelingen[idx].setAvailable(A,K,Q,J);
          }
          std::vector<std::string> &combinedK()
          {
              return d_combined;
          }
          
          void print();
          
      private:
          void combine();
          bool checkRij(std::string hand, bool full);
};

#endif
